Index: LMDZ5/trunk/libf/phylmd/1D_interp_cases.h
===================================================================
--- LMDZ5/trunk/libf/phylmd/1D_interp_cases.h	(revision 2018)
+++ LMDZ5/trunk/libf/phylmd/1D_interp_cases.h	(revision 2019)
@@ -4,10 +4,10 @@
       if (forcing_GCSSold) then
 
-       call get_uvd(it,timestep,fich_gcssold_ctl,fich_gcssold_dat,
-     :               ht_gcssold,hq_gcssold,hw_gcssold,
-     :               hu_gcssold,hv_gcssold,
-     :               hthturb_gcssold,hqturb_gcssold,Ts_gcssold,
-     :               imp_fcg_gcssold,ts_fcg_gcssold,
-     :               Tp_fcg_gcssold,Turb_fcg_gcssold)
+       call get_uvd(it,timestep,fich_gcssold_ctl,fich_gcssold_dat,              &
+     &               ht_gcssold,hq_gcssold,hw_gcssold,                          &
+     &               hu_gcssold,hv_gcssold,                                     &
+     &               hthturb_gcssold,hqturb_gcssold,Ts_gcssold,                 &
+     &               imp_fcg_gcssold,ts_fcg_gcssold,                            &
+     &               Tp_fcg_gcssold,Turb_fcg_gcssold)
        if (prt_level.ge.1) then
          print *,' get_uvd -> hqturb_gcssold ',it,hqturb_gcssold
@@ -38,25 +38,25 @@
 
        if (prt_level.ge.1) then
-        print*,
-     : '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_toga=',
-     :    day,day1,(day-day1)*86400.,(day-day1)*86400/dt_toga
+        print*,                                                             &
+     & '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_toga=',     &
+     &    day,day1,(day-day1)*86400.,(day-day1)*86400/dt_toga
        endif
 
 ! time interpolation:
-        CALL interp_toga_time(daytime,day1,annee_ref
-     i             ,year_ini_toga,day_ju_ini_toga,nt_toga,dt_toga
-     i             ,nlev_toga,ts_toga,plev_toga,t_toga,q_toga,u_toga
-     i             ,v_toga,w_toga,ht_toga,vt_toga,hq_toga,vq_toga
-     o             ,ts_prof,plev_prof,t_prof,q_prof,u_prof,v_prof,w_prof
-     o             ,ht_prof,vt_prof,hq_prof,vq_prof)
+        CALL interp_toga_time(daytime,day1,annee_ref                        &
+     &             ,year_ini_toga,day_ju_ini_toga,nt_toga,dt_toga           &
+     &             ,nlev_toga,ts_toga,plev_toga,t_toga,q_toga,u_toga        &
+     &             ,v_toga,w_toga,ht_toga,vt_toga,hq_toga,vq_toga           &
+     &             ,ts_prof,plev_prof,t_prof,q_prof,u_prof,v_prof,w_prof    &
+     &             ,ht_prof,vt_prof,hq_prof,vq_prof)
 
         if (type_ts_forcing.eq.1) ts_cur = ts_prof ! SST used in read_tsurf1d
 
 ! vertical interpolation:
-      CALL interp_toga_vertical(play,nlev_toga,plev_prof
-     :         ,t_prof,q_prof,u_prof,v_prof,w_prof
-     :         ,ht_prof,vt_prof,hq_prof,vq_prof
-     :         ,t_mod,q_mod,u_mod,v_mod,w_mod
-     :         ,ht_mod,vt_mod,hq_mod,vq_mod,mxcalc)
+      CALL interp_toga_vertical(play,nlev_toga,plev_prof                    &
+     &         ,t_prof,q_prof,u_prof,v_prof,w_prof                          &
+     &         ,ht_prof,vt_prof,hq_prof,vq_prof                             &
+     &         ,t_mod,q_mod,u_mod,v_mod,w_mod                               &
+     &         ,ht_mod,vt_mod,hq_mod,vq_mod,mxcalc)
 
 ! large-scale forcing :
@@ -84,29 +84,29 @@
       if (forcing_twpice) then
 
-        print*,
-     : '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_twpi=',
-     :    daytime,day1,(daytime-day1)*86400.,
-     :    (daytime-day1)*86400/dt_twpi
+        print*,                                                             &
+     & '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_twpi=',     &
+     &    daytime,day1,(daytime-day1)*86400.,                               &
+     &    (daytime-day1)*86400/dt_twpi
 
 ! time interpolation:
-        CALL interp_toga_time(daytime,day1,annee_ref
-     i       ,year_ini_twpi,day_ju_ini_twpi,nt_twpi,dt_twpi,nlev_twpi
-     i       ,ts_twpi,plev_twpi,t_twpi,q_twpi,u_twpi,v_twpi,w_twpi
-     i       ,ht_twpi,vt_twpi,hq_twpi,vq_twpi
-     o       ,ts_proftwp,plev_proftwp,t_proftwp,q_proftwp,u_proftwp
-     o       ,v_proftwp,w_proftwp
-     o       ,ht_proftwp,vt_proftwp,hq_proftwp,vq_proftwp)
+        CALL interp_toga_time(daytime,day1,annee_ref                        &
+     &       ,year_ini_twpi,day_ju_ini_twpi,nt_twpi,dt_twpi,nlev_twpi       &
+     &       ,ts_twpi,plev_twpi,t_twpi,q_twpi,u_twpi,v_twpi,w_twpi          &
+     &       ,ht_twpi,vt_twpi,hq_twpi,vq_twpi                               &
+     &       ,ts_proftwp,plev_proftwp,t_proftwp,q_proftwp,u_proftwp         &
+     &       ,v_proftwp,w_proftwp                                           &
+     &       ,ht_proftwp,vt_proftwp,hq_proftwp,vq_proftwp)
 
 ! vertical interpolation:
-      CALL interp_toga_vertical(play,nlev_twpi,plev_proftwp
-     :         ,t_proftwp,q_proftwp,u_proftwp,v_proftwp,w_proftwp
-     :         ,ht_proftwp,vt_proftwp,hq_proftwp,vq_proftwp
-     :         ,t_mod,q_mod,u_mod,v_mod,w_mod
-     :         ,ht_mod,vt_mod,hq_mod,vq_mod,mxcalc)
+      CALL interp_toga_vertical(play,nlev_twpi,plev_proftwp                 &
+     &         ,t_proftwp,q_proftwp,u_proftwp,v_proftwp,w_proftwp           &
+     &         ,ht_proftwp,vt_proftwp,hq_proftwp,vq_proftwp                 &
+     &         ,t_mod,q_mod,u_mod,v_mod,w_mod                               &
+     &         ,ht_mod,vt_mod,hq_mod,vq_mod,mxcalc)
 
 
 !calcul de l'advection verticale a partir du omega
-cCalcul des gradients verticaux
-cinitialisation
+!Calcul des gradients verticaux
+!initialisation
       d_t_z(:)=0.
       d_q_z(:)=0.
@@ -114,8 +114,6 @@
       d_q_dyn_z(:)=0.
       DO l=2,llm-1
-       d_t_z(l)=(temp(l+1)-temp(l-1))
-     &          /(play(l+1)-play(l-1))
-       d_q_z(l)=(q(l+1,1)-q(l-1,1))
-     &          /(play(l+1)-play(l-1))
+       d_t_z(l)=(temp(l+1)-temp(l-1))/(play(l+1)-play(l-1))
+       d_q_z(l)=(q(l+1,1)-q(l-1,1))/(play(l+1)-play(l-1))
       ENDDO
       d_t_z(1)=d_t_z(2)
@@ -124,5 +122,5 @@
       d_q_z(llm)=d_q_z(llm-1)
 
-cCalcul de l advection verticale
+!Calcul de l advection verticale
       d_t_dyn_z(:)=w_mod(:)*d_t_z(:)
       d_q_dyn_z(:)=w_mod(:)*d_q_z(:)
@@ -133,8 +131,6 @@
 !           if (phi(l).gt.5000.) then
         if (phi(l).gt.0.) then
-        u(l)=u(l)
-     .      +timestep*(u_mod(l)-u(l))/(2.*3600.)
-        v(l)=v(l) 
-     .      +timestep*(v_mod(l)-v(l))/(2.*3600.)
+        u(l)=u(l)+timestep*(u_mod(l)-u(l))/(2.*3600.)
+        v(l)=v(l)+timestep*(v_mod(l)-v(l))/(2.*3600.)
            endif    
         else
@@ -150,13 +146,9 @@
            if ((zz(l).le.16000.).and.(zz(l).gt.15000.)) then
              zfact=(zz(l)-15000.)/1000.
-        q(l,1)=q(l,1)
-     .      +timestep*(q_mod(l)-q(l,1))/(6.*3600.)*zfact
-        temp(l)=temp(l) 
-     .      +timestep*(t_mod(l)-temp(l))/(6.*3600.)*zfact
+        q(l,1)=q(l,1)+timestep*(q_mod(l)-q(l,1))/(6.*3600.)*zfact
+        temp(l)=temp(l)+timestep*(t_mod(l)-temp(l))/(6.*3600.)*zfact
            else if (zz(l).gt.16000.) then 
-        q(l,1)=q(l,1)
-     .      +timestep*(q_mod(l)-q(l,1))/(6.*3600.)
-        temp(l)=temp(l) 
-     .      +timestep*(t_mod(l)-temp(l))/(6.*3600.)
+        q(l,1)=q(l,1)+timestep*(q_mod(l)-q(l,1))/(6.*3600.)
+        temp(l)=temp(l)+timestep*(t_mod(l)-temp(l))/(6.*3600.)
            endif
         enddo    
@@ -189,15 +181,15 @@
        if (forcing_amma) then
 
-        print*,
-     : '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_amma=',
-     :    daytime,day1,(daytime-day1)*86400.,
-     :    (daytime-day1)*86400/dt_amma
+        print*,                                                             &
+     & '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_amma=',     &
+     &    daytime,day1,(daytime-day1)*86400.,                               &
+     &    (daytime-day1)*86400/dt_amma
 
 ! time interpolation using TOGA interpolation routine
-        CALL interp_amma_time(daytime,day1,annee_ref
-     i       ,year_ini_amma,day_ju_ini_amma,nt_amma,dt_amma,nlev_amma
-     i       ,vitw_amma,ht_amma,hq_amma,lat_amma,sens_amma
-     o       ,vitw_profamma,ht_profamma,hq_profamma,lat_profamma
-     :       ,sens_profamma)
+        CALL interp_amma_time(daytime,day1,annee_ref                        &
+     &       ,year_ini_amma,day_ju_ini_amma,nt_amma,dt_amma,nlev_amma       &
+     &       ,vitw_amma,ht_amma,hq_amma,lat_amma,sens_amma                  &
+     &       ,vitw_profamma,ht_profamma,hq_profamma,lat_profamma            &
+     &       ,sens_profamma)
 
       print*,'apres interpolation temporelle AMMA'
@@ -213,16 +205,16 @@
 ! vertical interpolation using TOGA interpolation routine:
 !      write(*,*)'avant interp vert', t_proftwp
-      CALL interp_toga_vertical(play,nlev_amma,plev_amma
-     :         ,th_profamma,q_profamma,u_profamma,v_profamma
-     :         ,vitw_profamma
-     :         ,ht_profamma,vt_profamma,hq_profamma,vq_profamma
-     :         ,t_mod,q_mod,u_mod,v_mod,w_mod
-     :         ,ht_mod,vt_mod,hq_mod,vq_mod,mxcalc)
+      CALL interp_toga_vertical(play,nlev_amma,plev_amma                      &
+     &         ,th_profamma,q_profamma,u_profamma,v_profamma                 &
+     &         ,vitw_profamma                                               &
+     &         ,ht_profamma,vt_profamma,hq_profamma,vq_profamma             &
+     &         ,t_mod,q_mod,u_mod,v_mod,w_mod                               &
+     &         ,ht_mod,vt_mod,hq_mod,vq_mod,mxcalc)
        write(*,*) 'Profil initial forcing AMMA interpole'
 
 
 !calcul de l'advection verticale a partir du omega
-cCalcul des gradients verticaux
-cinitialisation
+!Calcul des gradients verticaux
+!initialisation
       do l=1,llm
       d_t_z(l)=0.
@@ -231,8 +223,6 @@
 
       DO l=2,llm-1
-       d_t_z(l)=(temp(l+1)-temp(l-1))
-     &          /(play(l+1)-play(l-1))
-       d_q_z(l)=(q(l+1,1)-q(l-1,1))
-     &          /(play(l+1)-play(l-1))
+       d_t_z(l)=(temp(l+1)-temp(l-1))/(play(l+1)-play(l-1))
+       d_q_z(l)=(q(l+1,1)-q(l-1,1))/(play(l+1)-play(l-1))
       ENDDO
       d_t_z(1)=d_t_z(2)
@@ -250,5 +240,5 @@
 !        d_th_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)-omega(l)*d_t_z(l)
 !attention: on impose dth
-        d_th_adv(l) = alpha*omega(l)/rcpd+
+        d_th_adv(l) = alpha*omega(l)/rcpd+                                  &
      &         ht_mod(l)*(play(l)/pzero)**rkappa-omega(l)*d_t_z(l)
 !        d_th_adv(l) = 0.
@@ -275,6 +265,5 @@
 !       call lstendH(llm,omega,dt_dyn,dq_dyn,du_dyn, dv_dyn,
 !     :  q,temp,u,v,play)
-       call lstendH(llm,nqtot,omega,dt_dyn,dq_dyn,
-     :  q,temp,u,v,play)
+       call lstendH(llm,nqtot,omega,dt_dyn,dq_dyn,q,temp,u,v,play)
 
         do l=1,llm
@@ -290,16 +279,16 @@
       if (forcing_armcu) then
 
-        print*,
-     : '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_armcu=',
-     :    day,day1,(day-day1)*86400.,(day-day1)*86400/dt_armcu
+        print*,                                                             &
+     & '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_armcu=',    &
+     &    day,day1,(day-day1)*86400.,(day-day1)*86400/dt_armcu
 
 ! time interpolation:
 ! ATTENTION, cet appel ne convient pas pour TOGA !!
 ! revoir 1DUTILS.h et les arguments
-      CALL interp_armcu_time(daytime,day1,annee_ref
-     i            ,year_ini_armcu,day_ju_ini_armcu,nt_armcu,dt_armcu
-     i            ,nlev_armcu,sens_armcu,flat_armcu,adv_theta_armcu
-     i            ,rad_theta_armcu,adv_qt_armcu,sens_prof,flat_prof
-     i            ,adv_theta_prof,rad_theta_prof,adv_qt_prof)
+      CALL interp_armcu_time(daytime,day1,annee_ref                         &
+     &            ,year_ini_armcu,day_ju_ini_armcu,nt_armcu,dt_armcu        &
+     &            ,nlev_armcu,sens_armcu,flat_armcu,adv_theta_armcu          &
+     &            ,rad_theta_armcu,adv_qt_armcu,sens_prof,flat_prof         &
+     &            ,adv_theta_prof,rad_theta_prof,adv_qt_prof)
 
 ! vertical interpolation:
@@ -346,107 +335,24 @@
       if (forcing_sandu) then
 
-        print*,
-     : '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_sandu=',
-     :    day,day1,(day-day1)*86400.,(day-day1)*86400/dt_sandu
+        print*,                                                             &
+     & '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_sandu=',    &
+     &    day,day1,(day-day1)*86400.,(day-day1)*86400/dt_sandu 
 
 ! time interpolation:
 ! ATTENTION, cet appel ne convient pas pour TOGA !!
 ! revoir 1DUTILS.h et les arguments
-      CALL interp_sandu_time(daytime,day1,annee_ref
-     i             ,year_ini_sandu,day_ju_ini_sandu,nt_sandu,dt_sandu
-     i             ,nlev_sandu
-     i             ,ts_sandu,ts_prof)
+      CALL interp_sandu_time(daytime,day1,annee_ref                         &
+     &             ,year_ini_sandu,day_ju_ini_sandu,nt_sandu,dt_sandu       &
+     &             ,nlev_sandu                                              &
+     &             ,ts_sandu,ts_prof)
 
         if (type_ts_forcing.eq.1) ts_cur = ts_prof ! SST used in read_tsurf1d
 
 ! vertical interpolation:
-      CALL interp_sandu_vertical(play,nlev_sandu,plev_profs
-     :         ,t_profs,thl_profs,q_profs,u_profs,v_profs,w_profs
-     :         ,omega_profs,o3mmr_profs
-     :         ,t_mod,thl_mod,q_mod,u_mod,v_mod,w_mod
-     :         ,omega_mod,o3mmr_mod,mxcalc)
-!calcul de l'advection verticale
-cCalcul des gradients verticaux
-cinitialisation
-      d_t_z(:)=0.
-      d_q_z(:)=0.
-      d_t_dyn_z(:)=0.
-      d_q_dyn_z(:)=0.
-! schema centre
-!     DO l=2,llm-1
-!      d_t_z(l)=(temp(l+1)-temp(l-1))
-!    &          /(play(l+1)-play(l-1))
-!      d_q_z(l)=(q(l+1,1)-q(l-1,1))
-!    &          /(play(l+1)-play(l-1))
-! schema amont
-      DO l=2,llm-1
-       d_t_z(l)=(temp(l+1)-temp(l))/(play(l+1)-play(l))
-       d_q_z(l)=(q(l+1,1)-q(l,1))/(play(l+1)-play(l))
-!     print *,'l temp2 temp0 play2 play0 omega_mod',
-!    & temp(l+1),temp(l-1),play(l+1),play(l-1),omega_mod(l)
-      ENDDO
-      d_t_z(1)=d_t_z(2)
-      d_q_z(1)=d_q_z(2)
-      d_t_z(llm)=d_t_z(llm-1)
-      d_q_z(llm)=d_q_z(llm-1)
-
-!  calcul de l advection verticale
-! Confusion w (m/s) et omega (Pa/s) !!
-      d_t_dyn_z(:)=omega_mod(:)*d_t_z(:)
-      d_q_dyn_z(:)=omega_mod(:)*d_q_z(:)
-!     do l=1,llm
-!      print *,'d_t_dyn omega_mod d_t_z d_q_dyn d_q_z',
-!    :l,d_t_dyn_z(l),omega_mod(l),d_t_z(l),d_q_dyn_z(l),d_q_z(l)
-!     enddo
-
-
-! large-scale forcing : pour le cas Sandu ces forcages sont la SST
-! et une divergence constante -> profil de omega
-      tsurf = ts_prof
-      write(*,*) 'SST suivante: ',tsurf
-      do l = 1, llm
-       omega(l) = omega_mod(l)
-       omega2(l)= omega(l)/rg*airefi ! flxmass_w calcule comme ds physiq
-
-       alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
-!
-!      d_th_adv(l) = 0.0
-!      d_q_adv(l,1) = 0.0
-!CR:test advection=0
-!calcul de l'advection verticale
-        d_th_adv(l) = alpha*omega(l)/rcpd-d_t_dyn_z(l)
-!        print*,'temp adv',l,-d_t_dyn_z(l)
-        d_q_adv(l,1) = -d_q_dyn_z(l)
-!        print*,'q adv',l,-d_q_dyn_z(l)
-       dt_cooling(l) = 0.0
-      enddo
-      endif ! forcing_sandu
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-!---------------------------------------------------------------------
-! Interpolation forcing in time and onto model levels
-!---------------------------------------------------------------------
-      if (forcing_astex) then
-
-        print*,
-     : '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_astex=',
-     :    day,day1,(day-day1)*86400.,(day-day1)*86400/dt_astex
-
-! time interpolation:
-! ATTENTION, cet appel ne convient pas pour TOGA !!
-! revoir 1DUTILS.h et les arguments
-      CALL interp_astex_time(daytime,day1,annee_ref
-     i             ,year_ini_astex,day_ju_ini_astex,nt_astex,dt_astex
-     i             ,nlev_astex,div_astex,ts_astex,ug_astex,vg_astex
-     i             ,ufa_astex,vfa_astex,div_prof,ts_prof,ug_prof,vg_prof
-     i             ,ufa_prof,vfa_prof)
-
-        if (type_ts_forcing.eq.1) ts_cur = ts_prof ! SST used in read_tsurf1d
-
-! vertical interpolation:
-      CALL interp_astex_vertical(play,nlev_astex,plev_profa
-     :         ,t_profa,thl_profa,qv_profa,ql_profa,qt_profa
-     :         ,u_profa,v_profa,w_profa,tke_profa,o3mmr_profa
-     :         ,t_mod,thl_mod,qv_mod,ql_mod,qt_mod,u_mod,v_mod,w_mod
-     :         ,tke_mod,o3mmr_mod,mxcalc)
+      CALL interp_sandu_vertical(play,nlev_sandu,plev_profs                 &
+     &         ,t_profs,thl_profs,q_profs,u_profs,v_profs,w_profs           &
+     &         ,omega_profs,o3mmr_profs                                     &
+     &         ,t_mod,thl_mod,q_mod,u_mod,v_mod,w_mod                       &
+     &         ,omega_mod,o3mmr_mod,mxcalc)
 !calcul de l'advection verticale
 !Calcul des gradients verticaux
@@ -476,6 +382,6 @@
 !  calcul de l advection verticale
 ! Confusion w (m/s) et omega (Pa/s) !!
-      d_t_dyn_z(:)=w_mod(:)*d_t_z(:)
-      d_q_dyn_z(:)=w_mod(:)*d_q_z(:)
+      d_t_dyn_z(:)=omega_mod(:)*d_t_z(:)
+      d_q_dyn_z(:)=omega_mod(:)*d_q_z(:)
 !     do l=1,llm
 !      print *,'d_t_dyn omega_mod d_t_z d_q_dyn d_q_z',
@@ -484,10 +390,10 @@
 
 
-! large-scale forcing : pour le cas Astex ces forcages sont la SST
-! la divergence,ug,vg,ufa,vfa
+! large-scale forcing : pour le cas Sandu ces forcages sont la SST
+! et une divergence constante -> profil de omega
       tsurf = ts_prof
       write(*,*) 'SST suivante: ',tsurf
       do l = 1, llm
-       omega(l) = w_mod(l)
+       omega(l) = omega_mod(l)
        omega2(l)= omega(l)/rg*airefi ! flxmass_w calcule comme ds physiq
 
@@ -504,4 +410,87 @@
        dt_cooling(l) = 0.0
       enddo
+      endif ! forcing_sandu
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!---------------------------------------------------------------------
+! Interpolation forcing in time and onto model levels
+!---------------------------------------------------------------------
+      if (forcing_astex) then
+
+        print*,                                                             &
+     & '#### ITAP,day,day1,(day-day1)*86400,(day-day1)*86400/dt_astex=',    &
+     &    day,day1,(day-day1)*86400.,(day-day1)*86400/dt_astex
+
+! time interpolation:
+! ATTENTION, cet appel ne convient pas pour TOGA !!
+! revoir 1DUTILS.h et les arguments
+      CALL interp_astex_time(daytime,day1,annee_ref                         &
+     &             ,year_ini_astex,day_ju_ini_astex,nt_astex,dt_astex       &
+     &             ,nlev_astex,div_astex,ts_astex,ug_astex,vg_astex         &
+     &             ,ufa_astex,vfa_astex,div_prof,ts_prof,ug_prof,vg_prof    &
+     &             ,ufa_prof,vfa_prof)
+
+        if (type_ts_forcing.eq.1) ts_cur = ts_prof ! SST used in read_tsurf1d
+
+! vertical interpolation:
+      CALL interp_astex_vertical(play,nlev_astex,plev_profa                 &
+     &         ,t_profa,thl_profa,qv_profa,ql_profa,qt_profa                &
+     &         ,u_profa,v_profa,w_profa,tke_profa,o3mmr_profa               &
+     &         ,t_mod,thl_mod,qv_mod,ql_mod,qt_mod,u_mod,v_mod,w_mod        &
+     &         ,tke_mod,o3mmr_mod,mxcalc)
+!calcul de l'advection verticale
+!Calcul des gradients verticaux
+!initialisation
+      d_t_z(:)=0.
+      d_q_z(:)=0.
+      d_t_dyn_z(:)=0.
+      d_q_dyn_z(:)=0.
+! schema centre
+!     DO l=2,llm-1
+!      d_t_z(l)=(temp(l+1)-temp(l-1))
+!    &          /(play(l+1)-play(l-1))
+!      d_q_z(l)=(q(l+1,1)-q(l-1,1))
+!    &          /(play(l+1)-play(l-1))
+! schema amont
+      DO l=2,llm-1
+       d_t_z(l)=(temp(l+1)-temp(l))/(play(l+1)-play(l))
+       d_q_z(l)=(q(l+1,1)-q(l,1))/(play(l+1)-play(l))
+!     print *,'l temp2 temp0 play2 play0 omega_mod',
+!    & temp(l+1),temp(l-1),play(l+1),play(l-1),omega_mod(l)
+      ENDDO
+      d_t_z(1)=d_t_z(2)
+      d_q_z(1)=d_q_z(2)
+      d_t_z(llm)=d_t_z(llm-1)
+      d_q_z(llm)=d_q_z(llm-1)
+
+!  calcul de l advection verticale
+! Confusion w (m/s) et omega (Pa/s) !!
+      d_t_dyn_z(:)=w_mod(:)*d_t_z(:)
+      d_q_dyn_z(:)=w_mod(:)*d_q_z(:)
+!     do l=1,llm
+!      print *,'d_t_dyn omega_mod d_t_z d_q_dyn d_q_z',
+!    :l,d_t_dyn_z(l),omega_mod(l),d_t_z(l),d_q_dyn_z(l),d_q_z(l)
+!     enddo
+
+
+! large-scale forcing : pour le cas Astex ces forcages sont la SST
+! la divergence,ug,vg,ufa,vfa
+      tsurf = ts_prof
+      write(*,*) 'SST suivante: ',tsurf
+      do l = 1, llm
+       omega(l) = w_mod(l)
+       omega2(l)= omega(l)/rg*airefi ! flxmass_w calcule comme ds physiq
+
+       alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
+!
+!      d_th_adv(l) = 0.0
+!      d_q_adv(l,1) = 0.0
+!CR:test advection=0
+!calcul de l'advection verticale
+        d_th_adv(l) = alpha*omega(l)/rcpd-d_t_dyn_z(l)
+!        print*,'temp adv',l,-d_t_dyn_z(l)
+        d_q_adv(l,1) = -d_q_dyn_z(l)
+!        print*,'q adv',l,-d_q_dyn_z(l)
+       dt_cooling(l) = 0.0
+      enddo
       endif ! forcing_astex
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Index: LMDZ5/trunk/libf/phylmd/1D_nudge_sandu_astex.h
===================================================================
--- LMDZ5/trunk/libf/phylmd/1D_nudge_sandu_astex.h	(revision 2018)
+++ LMDZ5/trunk/libf/phylmd/1D_nudge_sandu_astex.h	(revision 2019)
@@ -20,15 +20,15 @@
 !     print *,'l dt  relax dtadv',l,dt_phys(l),relax_thl(l),d_th_adv(l)
       enddo
-        u(1:mxcalc)=u(1:mxcalc) + timestep*(
-     .              du_phys(1:mxcalc) - relax_u(1:mxcalc))
-        v(1:mxcalc)=v(1:mxcalc) + timestep*(
-     .	            dv_phys(1:mxcalc) - relax_v(1:mxcalc))
-c       q(1:mxcalc,:)=q(1:mxcalc,:)+timestep*(
-c    .              dq(1:mxcalc,:) - relax_q(1:mxcalc,:)+
-c    .              d_q_adv(1:mxcalc,:))
-        q(1:mxcalc,1)=q(1:mxcalc,1)+timestep*(
-     .      dq(1:mxcalc,1) - relax_q(1:mxcalc,1)+d_q_adv(1:mxcalc,1))
-        q(1:mxcalc,2)=q(1:mxcalc,2)+timestep*(
-     .      dq(1:mxcalc,2) - relax_q(1:mxcalc,2)+d_q_adv(1:mxcalc,2))
-        temp(1:mxcalc)=temp(1:mxcalc)+timestep*(
-     .      dt_phys(1:mxcalc)-relax_thl(1:mxcalc)+d_th_adv(1:mxcalc))
+        u(1:mxcalc)=u(1:mxcalc) + timestep*(                                &          
+     &              du_phys(1:mxcalc) - relax_u(1:mxcalc))
+        v(1:mxcalc)=v(1:mxcalc) + timestep*(                                &
+     &               dv_phys(1:mxcalc) - relax_v(1:mxcalc))
+!       q(1:mxcalc,:)=q(1:mxcalc,:)+timestep*(
+!    .              dq(1:mxcalc,:) - relax_q(1:mxcalc,:)+
+!    .              d_q_adv(1:mxcalc,:))
+        q(1:mxcalc,1)=q(1:mxcalc,1)+timestep*(                              &
+     &      dq(1:mxcalc,1) - relax_q(1:mxcalc,1)+d_q_adv(1:mxcalc,1))
+        q(1:mxcalc,2)=q(1:mxcalc,2)+timestep*(                              &
+     &      dq(1:mxcalc,2) - relax_q(1:mxcalc,2)+d_q_adv(1:mxcalc,2))
+        temp(1:mxcalc)=temp(1:mxcalc)+timestep*(                            &
+     &      dt_phys(1:mxcalc)-relax_thl(1:mxcalc)+d_th_adv(1:mxcalc))
